POJ 2718 Smallest Difference(贪心 or next_permutation暴力枚举)
Description
For example, if you are given the digits 0, 1, 2, 4, 6
and 7, you can write the pair of integers 10 and 2467. Of course, there are many
ways to form such pairs of integers: 210 and 764, 204 and 176, etc. The absolute
value of the difference between the integers in the last pair is 28, and it
turns out that no other pair formed by the rules above can achieve a smaller
difference.
Input
to follow. For each case, there is one line of input containing at least two but
no more than 10 decimal digits. (The decimal digits are 0, 1, ..., 9.) No digit
appears more than once in one line of the input. The digits will appear in
increasing order, separated by exactly one blank space.
Output
smallest absolute difference of two integers that can be written from the given
digits as described by the rules above.
Sample Input
1
0 1 2 4 6 7
Sample Output
28
Source
题意:给一升序集合 集合中元素范围为1~9 从中寻找两个不相交子集(每个数只能用一次) 求这两个子集组成两个整数的差最小值
这题要注意一个情况,除了组成的数只有0,否则都不能以0为开头,如01是不存在的, 它并不等于1。 如果输入012,那么答案是 10-2 = 8,并不是2-1(01) = 1。
分析:这道题数据量很小 可以用next_permutation 来枚举所有的情况 由于只是要找差最小 所以枚举完只需要把枚举的情况从前到后组成两个位数相等(偶数情况) 或者 位数差1(奇数情况)的数 然后相减取绝对值(避免先后问题),然后取这些情况的最小值即可。
next_permutation函数将按字母表顺序生成给定序列的下一个较大的序列,直到整个序列为减序为止,使用方法是next_permutation(begin(),end())。
代码中以一个地方写的很妙 可以排除所有首元素为0的情况:
while(a[0] ==0)
next_permutation(a,a+cnt);//第一个数不能为0
因为next_permutation函数不会重复生成已经生成过的序列
这样就先排除了所有首数字为0的情况
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cstring>
#include <math.h>
#include <stdlib.h>
#include <time.h>
using namespace std;
char aa[];
int a[];
int cnt, mid, ans;
int main()
{
int t;
scanf("%d", &t);
getchar();
while(t--)
{
cnt = ;
int t;
while((t = getchar()) != '\n')
{
if(t != ' ')
{
aa[cnt] = t;
cnt++;
}
} int mid = cnt/;
ans = 1e9;
if(cnt == )
{
printf("%d\n",aa[]-aa[]);
continue;
}
for(int i = ; i < cnt; i++)
{
a[i] = aa[i] - '';
}
while(a[] ==)
next_permutation(a,a+cnt);//第一个数不能为0
do
{
if(a[mid])
{
int t1=,t2=;
for(int i=;i<mid;++i)
t1=t1*+a[i];
for(int i=mid;i<cnt;++i)
t2=t2*+a[i];
ans=min(ans,abs(t1-t2));
} }while(next_permutation(a,a+cnt));
printf("%d\n",ans); }
}
Next_permutation
前面说过 这题数据量很小 可以用枚举来实现 复杂度为O(n²) 但如果数据量增大 枚举就行不通了 这时候可以使用贪心的思想来做这道题。
设t1为大数 t2为小数
如果是奇数的情况 那么因为t1的位数比t2多一位 那么t1最高位挑选最小的元素 t2最高位挑选次小的元素 然后t1依次挑选尽可能小的元素 t2依次挑选尽可能大的元素 组成的数t1-t2就是答案
如果是偶数的情况 那么就需要枚举一下每个相邻的位 t1的最高位挑选相邻位置中较大的元素 t2最高位挑选相邻位置较大的元素 然后t1依次挑选尽可能小的元素 t2挑选尽可能大的元素
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cstring>
#include <math.h>
#include <stdlib.h>
#include <time.h>
using namespace std;
char aa[];
int a[];
int cnt, mid;
int main()
{
//freopen("1.txt","r",stdin);
//freopen("2.txt","w",stdout);
int t;
scanf("%d", &t);
getchar();
while(t--)
{
cnt = ;
int t;
while((t = getchar()) != '\n')
{
if(t != ' ')
{
aa[cnt] = t;
cnt++;
}
} int mid = cnt/; // printf("%d\n",cnt);
if(cnt == )
{
printf("%d\n",aa[]-aa[]);
continue;
}
for(int i = ; i < cnt; i++)
{
a[i] = aa[i] - '';
}
if(cnt % == )//偶数情况
{
int t1,t2;//t1小数 t2大数
bool vis[];
memset(vis,,sizeof(vis));
int ans = 1e9; for(int i = ; i < cnt-;i++)
{
if(a[i] == ) continue;
t1 = a[i];
t2 = a[i+];
// printf("1 %d %d\n",t2, t1);
vis[i]=;vis[i+] = ;
int ti = ,pos = cnt - ;
while(ti < cnt/- && pos >= )
{
if(!vis[pos])
{
t1 = t1* + a[pos];
vis[pos] = ;
ti++;
}
pos--;
}
ti = ,pos = ;
while(ti < cnt/- && pos < cnt)
{
if(!vis[pos])
{
t2 = t2* + a[pos];
ti++;
vis[pos] = ;
}
pos++;
}
memset(vis,,sizeof(vis));
// printf("2 %d %d\n",t2, t1);
ans = min(ans,t2- t1);
} printf("%d\n",ans);
}
else//奇数情况
{
int t1 , t2;//t1为大数 t2 为小数
if(a[] != )
{
t1 = a[];
t2 = a[cnt-];
for(int i = ; i <= mid;i++)
{
if(i == ) continue;
t1 = t1* + a[i];
}
for(int i = cnt-; i > mid; i--)
{
t2 = t2* + a[i];
}
printf("%d\n",t1-t2);
}
else
{
t1 = a[];
t2 = a[cnt-];
for(int i = ; i <= mid;i++)
{
if(i == ) continue;
t1 = t1* + a[i];
}
for(int i = cnt-; i > mid; i--)
{
t2 = t2* + a[i];
}
printf("%d\n",t1-t2);
} } }
}
贪心
POJ 2718 Smallest Difference(贪心 or next_permutation暴力枚举)的更多相关文章
- POJ 2718 Smallest Difference(最小差)
Smallest Difference(最小差) Time Limit: 1000MS Memory Limit: 65536K Description - 题目描述 Given a numb ...
- poj 2718 Smallest Difference(暴力搜索+STL+DFS)
Smallest Difference Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 6493 Accepted: 17 ...
- POJ 2718 Smallest Difference dfs枚举两个数差最小
Smallest Difference Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 19528 Accepted: 5 ...
- 穷竭搜索: POJ 2718 Smallest Difference
题目:http://poj.org/problem?id=2718 题意: 就是输入N组数据,一组数据为,类似 [1 4 5 6 8 9]这样在0~9之间升序输入的数据,然后从这些数据中切一 ...
- POJ 2718 Smallest Difference 枚举
http://poj.org/problem?id=2718 题目大意: 给你一些数字(单个),不会重复出现且从小到大.他们可以组成两个各个位上的数字均不一样的数,如 0, 1, 2, 4, 6 ,7 ...
- POJ 2718 Smallest Difference【DFS】
题意: 就是说给你一些数,然后要求你使用这些数字组成2个数,然后求他们的差值最小. 思路: 我用的双重DFS做的,速度还比较快,其中有一个很重要的剪枝,若当前搜索的第二个数后面全部补零与第一个数所产生 ...
- poj 2718 Smallest Difference(穷竭搜索dfs)
Description Given a number of distinct , the integer may not start with the digit . For example, , , ...
- POJ - 2718 Smallest Difference(全排列)
题意:将n个数字分成两组,两组分别组成一个数字,问两个数字的最小差值.要求,当组内数字个数多于1个时,组成的数字不允许有前导0.(2<=n<=10,每个数字范围是0~9) 分析: 1.枚举 ...
- POJ 2718 Smallest Difference(dfs,剪枝)
枚举两个排列以及有那些数字,用dfs比较灵活. dfs1是枚举长度短小的那个数字,dfs2会枚举到比较大的数字,然后我们希望低位数字的差尽量大, 后面最优全是0,如果全是0都没有当前ans小的话就剪掉 ...
随机推荐
- BZOJ2553 [BJWC2011]禁忌
传送门 Description 给你前alphabet个小写字母组成的字符集, 以及n个单词, 定义一个串s的禁忌值为 \(\sum_{i } [s[i] == Taboo[i]]\) , Tab ...
- tabBar隐藏方式
如果是从A push到B,并且把A的一个东西传到B,那么在push时就要隐藏tabBar,并且要在B ViewController设置一个接收A传到的属性. 这种方式一般用在表格点选,要把表格点选的内 ...
- 436 Find Right Interval 寻找右区间
给定一组区间,对于每一个区间 i,检查是否存在一个区间 j,它的起始点大于或等于区间 i 的终点,这可以称为 j 在 i 的“右侧”.对于任何区间,你需要存储的满足条件的区间 j 的最小索引,这意味着 ...
- 214 Shortest Palindrome 最短回文串
给一个字符串 S, 你可以通过在字符串前面添加字符将其转换为回文串.找到并返回可以用这种方式转换的最短回文串.例如:给出 "aacecaaa",返回 "aaacecaaa ...
- python_基础部分(1)
第1章 Python介绍 1.1 基础介绍 l 代码:代码的出现是为了解决生活中的问题 l 编译解释器:目的是让解释器将代码翻译成计算机可识别的语言 l 编程语言:按照一定规则写出来的语言, C ...
- windows8.1专业版 关闭ie11总是已停止工作
该问题通常原因: 1 系统重病毒: 2 系统和安装的软件不兼容导致. 解决方案: 1 杀毒更新至最新进行杀毒,仍未解决,重新安装系统: 2 目前身边人员多数属于该情况: 1 如安装了输入法.迅雷或其它 ...
- Redis和SpringDataRedis
一.Redis简介 Redis是用C语言开发的一个开源的高性能键值对(key-value)数据库,运行在内存中,由ANSI C编写.企业开发通常采用Redis来实现缓存.同类的产品还有memcac ...
- jq判断上下滚动
$(document).ready(function(){ var p=0,t=0; $(window).scroll(function(e){ p = $(this).scrollTop(); if ...
- LN : leetcode 123 Best Time to Buy and Sell Stock III
lc 123 Best Time to Buy and Sell Stock III 123 Best Time to Buy and Sell Stock III Say you have an a ...
- e.Row.RowType == DataControlRowType.DataRow详解(转)
代码语句如下: protected void OnRowCreate(object sender, GridViewRowEventArgs e) { if (e.Row.RowT ...